<template>
  <div class="h-screen flex justify-center sidebar">
    <div
      class="background-login w-full md:w-full lg:w-1/2"
      :class="backgrounByTheme"
    >
      <div class="flex justify-between pr-2 items-center">
        <p
          class="py-2 pl-6 text-[var(--secondary)] text-base font-medium uppercase"
          :class="colorByTheme"
        >
          {{ $t("Login Page") }}
        </p>
        <div class="mr-1 icon-lang">
          <img
            :src="handleImportImage(`icon/${telegramLang}.svg`)"
            class="w-[20px]"
            loading="lazy"
            @click="changeLanguage = true"
          />
        </div>
        <el-dialog
          v-model="changeLanguage"
          destroy-on-close
          width="260px"
          custom-class="change-language"
          :show-close="false"
        >
          <template #title>
            <div
              class="flex items-center py-2 px-4"
              @click="changeLanguage = false"
            >
              <p>Select Language</p>
              <font-awesome-icon
                :icon="['fas', 'angle-right']"
                class="text-[15px] absolute right-[10px]"
              />
            </div>
            <el-divider class="remove-margin" />
          </template>
          <div class="h-[90vh]">
            <a
              v-for="lang in languageSetting"
              :key="lang.ISO"
              href="#"
              class="flex py-2 px-3"
              @click.prevent="switchLanguage(lang.ISO)"
            >
              <img
                :src="handleImportImage(`icon/${lang.ISO}.svg`)"
                class="w-[20px]"
                loading="lazy"
              />
              <span
                class="flex-1 ml-3 whitespace-nowrap"
                :class="lang.ISO === telegramLang ? 'active-color' : ''"
                >{{ lang.LanguageLocalName }}</span
              >
              <font-awesome-icon
                v-if="lang.ISO === telegramLang"
                icon="check"
                class="text-[15px] checked-lang active-color"
              />
            </a>
          </div>
        </el-dialog>
      </div>
      <hr class="bg-border border-1" />
      <el-form class="px-3" :model="formModel">
        <div class="w-full p-3 mx-auto">
          <el-form
            ref="loginFormRef"
            label-position="top"
            :model="loginFormData"
            :rules="loginRules"
            :validate-on-rule-change="false"
            class="w-full mx-auto"
          >
            <el-form-item :label="$t('username')" prop="Username">
              <el-input
                v-model="loginFormData.Username"
                :placeholder="$t('Please insert your username...')"
                type="text"
              />
            </el-form-item>
            <el-form-item :label="$t('password')" prop="Password">
              <el-input
                v-model="loginFormData.Password"
                show-password
                :placeholder="$t('Please insert your password...')"
                type="password"
              />
            </el-form-item>
            <template class="flex justify-center">
              <div class="mt-10">
                <el-button
                  type="success"
                  :disabled="isLoginProccessing"
                  :loading="isLoginProccessing"
                  round
                  class="px-4 py-1 text-sm w-full rounded btn"
                  :class="buttonColorByTheme"
                  @click="onSubmitLogin"
                  >{{ $t("log_in") }}</el-button
                >
              </div>
            </template>
          </el-form>
        </div>
      </el-form>
    </div>
  </div>
</template>
<script lang="ts">
import { defineComponent, watch, ref, computed } from "vue";
import { Check } from "@element-plus/icons-vue";
import { useLanguageComponent } from "../composables/useTheme";
import { ILanguage } from "../models/common/language";
import commonHelper from "../utils/commonHelper";
import useLogin from "../composables/useLogin";
import { store } from "~~/store";

export default defineComponent({
  setup() {
    const {
      loginFormRef,
      loginFormData,
      loginRules,
      submitLogin,
      isLoginProccessing,
      register,
      isSubmitSuccess,
    } = useLogin();
    let telegramClose: () => void;
    const {
      languages,
      defaultLanguage,
      switchLanguage,
      isLanguageLoading,
      defaultLanguageForDisplay,
      languageSetting,
      telegramLang,
    } = useLanguageComponent();
    const handleImportImage = commonHelper.handleImportCommonImage;
    const { getAssetImage } = commonHelper;
    const changeLanguage = ref<boolean>(false);
    const importTelegram = async () => {
      try {
        const { useWebApp } = await import("vue-tg");
        const { close } = useWebApp();
        telegramClose = close;
      } catch (error) {
        console.log(error);
      }
    };
    importTelegram();
    const onSubmitLogin = () => {
      submitLogin(loginFormRef.value);
    };
    watch(
      () => isSubmitSuccess.value,
      () => {
        setTimeout(function () {
          if (typeof telegramClose === "function") {
            telegramClose();
          }
        }, 2000);
      }
    );
    const themeName = store.state.selectedThemeName;
    const colorByTheme = computed(() => {
      if (themeName === "modern") {
        return "text-[var(--title-font-color)]";
      }
      if (themeName === "peru") {
        return "text-[var(--secondary)]";
      }
      return "text-login";
    });
    const backgrounByTheme = computed(() => {
      if (themeName === "playful") {
        return "bg-[var(--background2)]";
      }
      return "bg-[var(--background5)]";
    });
    const buttonColorByTheme = computed(() => {
      if (themeName === "sbo") {
        return "bg-primary";
      }
      return "bg-secondary";
    });
    return {
      telegramLang,
      loginFormRef,
      loginFormData,
      loginRules,
      submitLogin,
      isLoginProccessing,
      register,
      onSubmitLogin,
      themeName,
      colorByTheme,
      backgrounByTheme,
      buttonColorByTheme,
      languageSetting,
      languages,
      defaultLanguage,
      switchLanguage,
      isLanguageLoading,
      defaultLanguageForDisplay,
      handleImportImage,
      getAssetImage,
      Check,
      changeLanguage,
    };
  },
});
</script>
<style lang="scss">
.background-login {
  height: 100vh;
  color: white;
}
.text-login {
  color: var(--text5);
}
.el-input__inner {
  background: var(--background-body);
}
.telegram-poper {
  inset: 0px 0px auto 208px !important;
}
.remove-margin {
  margin: 4px 0px 4px 0px;
}
.change-language.el-dialog {
  --el-dialog-bg-color: var(--background5);
}
.active-color {
  color: var(--primary);
}
.change-language {
  .el-dialog__header {
    padding: 0px !important;
    margin-right: 0px;
  }
  .el-dialog__body {
    padding-top: 0px !important;
  }
  position: absolute;
  top: 0px;
  right: 0px;
  margin: 0px;
}
.change-language.el-dialog:focus-visible {
  outline: transparent;
}
</style>
